<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" size="small">
      <template v-if="!checkRole(['entAdmin','entUser'])">
        <el-form-item label="省" prop="provinceId">
            <el-select v-model="queryParams.provinceId" placeholder="请选择省" @change="getCityData" filterable style="width: 200px;">
              <el-option v-for="(item,index) in provinceDataList" :key="index" :label="item.name" :value="item.id"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="市" prop="cityId">
            <el-select v-model="queryParams.cityId" placeholder="请选择市" @change="getDistrictData" filterable style="width: 200px;">
              <el-option v-for="(item, index) in cityDataList" :key="index" :label="item.name" :value="item.id"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="区" prop="districtId">
            <el-select v-model="queryParams.districtId" placeholder="请选择区" filterable style="width: 200px;">
              <el-option v-for="(item, index) in districtDataList" :key="index" :label="item.name" :value="item.id"></el-option>
            </el-select>
          </el-form-item>
        <el-form-item label="年份" prop="year">
          <el-date-picker v-model="years" type="years" placeholder="选择一个或多个年份" style="width: 200px;" value-format="yyyy"></el-date-picker>
        </el-form-item>
        <el-form-item label="企业名称" prop="entName">
          <el-input v-model="queryParams.entName" clearable style="width: 200px;" placeholder="请输入企业名称"></el-input>
        </el-form-item>
        <el-form-item label="社会信用代码" prop="license">
          <el-input v-model="queryParams.license" style="width: 200px;" placeholder="请输入社会信用代码"></el-input>
        </el-form-item>
      </template>
      <el-form-item label="项目编号" prop="projectNo">
        <el-input v-model="queryParams.projectNo" style="width: 200px;" placeholder="请输入项目编号"></el-input>
      </el-form-item>
      <el-form-item label="项目名称" prop="projectName">
        <el-input v-model="queryParams.projectName" style="width: 200px;" placeholder="请输入项目名称"></el-input>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" @click="handleQuery">搜索</el-button>
        <el-button @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <h3 class="toolbar">
      <span class="title">列表</span>
      <div class="tool">
         <el-button type="primary" plain icon="el-icon-delete" size="mini" @click="handleBatchDel" v-if="roleType == 'entAdmin' || roleType == 'entUser' || roleType == 'manager'">批量删除</el-button>
        <el-button type="primary" plain icon="el-icon-download" size="mini" @click="handleDownloadBatch">下载</el-button>
      </div>
    </h3>
    <el-table v-loading="loading" :data="list" border @selection-change="handleSelectionChange" style="width: 100%">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="项目编号" prop="projectNo" align="center" />
      <el-table-column label="项目名称" prop="projectName" align="center"></el-table-column>
      <el-table-column label="企业名称" prop="entName" align="center"/>
      <el-table-column label="社会信用代码" prop="license" align="center"/>
      <el-table-column label="项目年份" prop="projectYear" align="center"/>
      <el-table-column label="项目跨年" prop="overYearFlag" align="center" :formatter="fmtOverYear"></el-table-column>
      <el-table-column label="创建时间" align="center" prop="createTime" width="160"></el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="180" fixed="right">
        <template slot-scope="scope">
          <el-button type="text" @click="handleView(scope.row)">查看</el-button>
          <el-button type="text" @click="handleDelete(scope.row)">删除</el-button>
          <template v-if="scope.row.attachCnt != 0">
            <el-button type="text" @click="handleDownload(scope.row)">下载</el-button>
          </template>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
  </div>
</template>
<!-- 科德管理员、企业角色、税务角色都有项目申报角色 -->
<script>
  import {getProvinceDataApi,getRegionChildrenApi} from "@/api/common/common"
  import {listDeclareApi,listDeclareCommonApi,projectBackApi} from '@/api/enterprise/declare/declare'
  import {entStateOptions, getLabel, authStateOptions,yesOrNoOptions} from '@/utils/dataFormat'
  import { downLoadZip } from "@/utils/zipdownload";
  import { checkRole } from "@/utils/permission"; // 权限判断函数
  export default {
    data () {
      return {
        years: [],
        loading: false,
        provinceDataList: [],
        cityDataList: [],
        districtDataList: [],
        ids: [],
        selectCount: '',
        entStateOptions: entStateOptions,
        authStateOptions: authStateOptions,
        yesOrNoOptions: yesOrNoOptions,
        roleType: '',
        queryParams: {
          pageNum: 1,
          pageSize: 10,
          provinceId: undefined,
          cityId: undefined,
          districtId: undefined,
          year: '',
          entName: '',
          license: '',
          projectNo: '',
          projectName: ''
        },
        list: [],
        total: 0,
        open: false,
        openInfo: false,
      }
    },
    created() {
      this.roleType = this.roles.join(',')
      this.getList()
      if(this.userType == 'GOV_PROV' || this.userType == 'GOV_CITY') {
        this.getAreaData()
      }
      if(this.roleType != 'gov') {
        this.getProvinceData()
      }
    },
    computed: {
      roles() {
        return this.$store.state.user.roles
      },
      scopeId() {
        return this.$store.state.user.scopeId
      },
      userType() {
        return this.$store.state.user.userType
      }
    },
    methods: {
      checkRole,
      handleDownloadBatch() {
        if(this.selectCount <= 0) {
          this.$message.error('请选择要下载的项目');
          return
        }
        const delIds = this.ids.join(',')
        downLoadZip('/project/download/' +delIds, "项目附件")
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.id)
        this.selectCount = selection.length;
      },
      handleBatchDel() {
        if(this.selectCount <= 0) {
          this.$message.error('请选择要删除的数据');
          return
        }
        const delIds = this.ids.join(',')
        this.$confirm('是否确认删除该数据?', "警告", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(function() {
            return projectBackApi(delIds);
          }).then(() => {
            this.queryParams.pageNum = 1;
            this.getList();
            this.$message({
              message: '删除成功',
              type: 'success'
            });
          })
      },
      getAreaData() {
        getRegionChildrenApi(this.scopeId).then(res => {
          if(res.code == 200) {
            if(this.userType == 'GOV_PROV') {
              this.cityDataList = res.data
            }else if(this.userType == 'GOV_CITY') {
              this.districtDataList = res.data
            }
          }
        })
      },
      //选择省份
      getCityData() {
        this.queryParams.cityId = ''
        this.queryParams.districtId = ''
        getRegionChildrenApi(this.queryParams.provinceId).then(res => {
          if(res.code == 200) {
            this.cityDataList = res.data
          }
        })
      },
      //选择市
      getDistrictData() {
        this.queryParams.districtId = ''
        getRegionChildrenApi(this.queryParams.cityId).then(res => {
          if(res.code == 200) {
            this.districtDataList = res.data
          }
        })
      },
      getProvinceData() {
        getProvinceDataApi().then(res => {
          if(res.code == 200) {
            this.provinceDataList = res.data
          }
        })
      },
      getList() {
        this.loading = true;
        this.queryParams.year = this.years.join(',')
        listDeclareCommonApi(this.queryParams).then(response => {
          this.list = response.data.records;
          this.total = response.data.total;
          this.loading = false;
        });
      },
      handleDownload(row) {
        downLoadZip('/project/download/' +row.id, "项目附件")
      },
      // 查看
      handleView(row) {
        this.$router.push("/declare/info/"+row.id)
      },
      handleDelete(row) {
        const id = row.id;
        this.$confirm('是否确认删除该数据?', "警告", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(function() {
            return projectBackApi(id);
          }).then(() => {
            this.queryParams.pageNum = 1;
            this.getList();
            this.$message({
              message: '删除成功',
              type: 'success'
            });
          })
      },
      // 重置
      resetQuery() {
        this.years = [];
        this.resetForm("queryForm");
        this.handleQuery();
      },
      // 搜索
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      statusFormat(row, col, val, index) {
        return getLabel(accessStatus, val)
      },
      entSateFormat(row, col, val, index) {
        return getLabel(entStateOptions, val)
      },
      authStateFormat(row, col, val, index) {
        return getLabel(authStateOptions, val)
      },
      fmtOverYear(row, col, val, index) {
        return getLabel(yesOrNoOptions, val)
      }
    }
  }
</script>

<style>
</style>
